function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from "react";
import { View } from "react-native";

const equilateralHeight = base => base / 2 * Math.sqrt(3);

const equilateralSide = base => base / 2;

const isoscelesHeight = height => height;

const isoscelesBase = base => base / 2;

const Triangle = (_ref) => {
  let {
    mode,
    base,
    color,
    type = "equilateral",
    height,
    left,
    right,
    style
  } = _ref,
      otherProps = _objectWithoutProperties(_ref, ["mode", "base", "color", "type", "height", "left", "right", "style"]);

  let triangleStyle = {
    width: 0,
    height: 0,
    borderStyle: "solid"
  };

  switch (mode) {
    case "top":
      triangleStyle = _objectSpread(_objectSpread({}, triangleStyle), {}, {
        borderTopColor: "transparent",
        borderLeftColor: "transparent",
        borderRightColor: "transparent",
        borderBottomColor: color
      });
      break;

    case "bottom":
      triangleStyle = _objectSpread(_objectSpread({}, triangleStyle), {}, {
        borderBottomColor: "transparent",
        borderLeftColor: "transparent",
        borderRightColor: "transparent",
        borderTopColor: color
      });
      break;

    case "left":
      triangleStyle = _objectSpread(_objectSpread({}, triangleStyle), {}, {
        borderTopColor: "transparent",
        borderBottomColor: "transparent",
        borderLeftColor: "transparent",
        borderRightColor: color
      });
      break;

    case "right":
      triangleStyle = _objectSpread(_objectSpread({}, triangleStyle), {}, {
        borderTopColor: "transparent",
        borderBottomColor: "transparent",
        borderRightColor: "transparent",
        borderLeftColor: color
      });
      break;

    case "bottom-left":
      triangleStyle = _objectSpread(_objectSpread({}, triangleStyle), {}, {
        borderTopColor: "transparent",
        borderBottomColor: "transparent",
        borderRightColor: "transparent",
        borderLeftColor: color
      });
      break;

    case "bottom-right":
      triangleStyle = _objectSpread(_objectSpread({}, triangleStyle), {}, {
        borderTopColor: "transparent",
        borderLeftColor: "transparent",
        borderRightColor: "transparent",
        borderBottomColor: color
      });
      break;

    case "top-left":
      triangleStyle = _objectSpread(_objectSpread({}, triangleStyle), {}, {
        borderBottomColor: "transparent",
        borderLeftColor: "transparent",
        borderRightColor: "transparent",
        borderTopColor: color
      });
      break;

    case "top-right":
      triangleStyle = _objectSpread(_objectSpread({}, triangleStyle), {}, {
        borderTopColor: "transparent",
        borderBottomColor: "transparent",
        borderLeftColor: "transparent",
        borderRightColor: color
      });
      break;

    default:
      break;
  }

  switch (type) {
    case "equilateral":
      switch (mode) {
        case "top":
          triangleStyle = _objectSpread(_objectSpread({}, triangleStyle), {}, {
            borderTopWidth: 0,
            borderRightWidth: equilateralSide(base),
            borderLeftWidth: equilateralSide(base),
            borderBottomWidth: equilateralHeight(base)
          });
          break;

        case "bottom":
          triangleStyle = _objectSpread(_objectSpread({}, triangleStyle), {}, {
            borderTopWidth: equilateralHeight(base),
            borderRightWidth: equilateralSide(base),
            borderLeftWidth: equilateralSide(base),
            borderBottomWidth: 0
          });
          break;

        case "left":
          triangleStyle = _objectSpread(_objectSpread({}, triangleStyle), {}, {
            borderTopWidth: equilateralSide(base),
            borderRightWidth: equilateralHeight(base),
            borderLeftWidth: 0,
            borderBottomWidth: equilateralSide(base)
          });
          break;

        case "right":
          triangleStyle = _objectSpread(_objectSpread({}, triangleStyle), {}, {
            borderTopWidth: equilateralSide(base),
            borderRightWidth: 0,
            borderLeftWidth: equilateralHeight(base),
            borderBottomWidth: equilateralSide(base)
          });
          break;

        default:
          break;
      }

      break;

    case "isosceles":
      switch (mode) {
        case "top":
          triangleStyle = _objectSpread(_objectSpread({}, triangleStyle), {}, {
            borderTopWidth: 0,
            borderRightWidth: isoscelesBase(base),
            borderLeftWidth: isoscelesBase(base),
            borderBottomWidth: isoscelesHeight(height)
          });
          break;

        case "bottom":
          triangleStyle = _objectSpread(_objectSpread({}, triangleStyle), {}, {
            borderTopWidth: isoscelesHeight(height),
            borderRightWidth: isoscelesBase(base),
            borderLeftWidth: isoscelesBase(base),
            borderBottomWidth: 0
          });
          break;

        case "left":
          triangleStyle = _objectSpread(_objectSpread({}, triangleStyle), {}, {
            borderTopWidth: isoscelesBase(base),
            borderRightWidth: isoscelesHeight(height),
            borderLeftWidth: 0,
            borderBottomWidth: isoscelesBase(base)
          });
          break;

        case "right":
          triangleStyle = _objectSpread(_objectSpread({}, triangleStyle), {}, {
            borderTopWidth: isoscelesBase(base),
            borderRightWidth: 0,
            borderLeftWidth: isoscelesHeight(height),
            borderBottomWidth: isoscelesBase(base)
          });
          break;

        default:
          break;
      }

      break;

    case "scalene":
      switch (mode) {
        case "top":
          triangleStyle = _objectSpread(_objectSpread({}, triangleStyle), {}, {
            borderTopWidth: 0,
            borderRightWidth: right,
            borderLeftWidth: left,
            borderBottomWidth: height
          });
          break;

        case "bottom":
          triangleStyle = _objectSpread(_objectSpread({}, triangleStyle), {}, {
            borderTopWidth: height,
            borderRightWidth: right,
            borderLeftWidth: left,
            borderBottomWidth: 0
          });
          break;

        case "left":
          triangleStyle = _objectSpread(_objectSpread({}, triangleStyle), {}, {
            borderTopWidth: right,
            borderRightWidth: height,
            borderLeftWidth: 0,
            borderBottomWidth: left
          });
          break;

        case "right":
          triangleStyle = _objectSpread(_objectSpread({}, triangleStyle), {}, {
            borderTopWidth: right,
            borderRightWidth: 0,
            borderLeftWidth: height,
            borderBottomWidth: left
          });
          break;

        default:
          break;
      }

      break;

    case "rightAngle":
      switch (mode) {
        case "bottom-left":
          triangleStyle = _objectSpread(_objectSpread({}, triangleStyle), {}, {
            borderTopWidth: height,
            borderRightWidth: 0,
            borderLeftWidth: base,
            borderBottomWidth: 0
          });
          break;

        case "bottom-right":
          triangleStyle = _objectSpread(_objectSpread({}, triangleStyle), {}, {
            borderTopWidth: 0,
            borderRightWidth: 0,
            borderLeftWidth: base,
            borderBottomWidth: height
          });
          break;

        case "top-left":
          triangleStyle = _objectSpread(_objectSpread({}, triangleStyle), {}, {
            borderTopWidth: height,
            borderRightWidth: base,
            borderLeftWidth: 0,
            borderBottomWidth: 0
          });
          break;

        case "top-right":
          triangleStyle = _objectSpread(_objectSpread({}, triangleStyle), {}, {
            borderTopWidth: 0,
            borderRightWidth: base,
            borderLeftWidth: 0,
            borderBottomWidth: height
          });
          break;

        default:
          break;
      }

      break;

    default:
      break;
  }

  return /*#__PURE__*/React.createElement(View, _extends({
    style: [triangleStyle, style]
  }, otherProps));
};

export default Triangle;
//# sourceMappingURL=index.js.map