import { ViewProps } from "react-native";
export declare type triangleTypeTypes = "equilateral" | "isosceles" | "scalene" | "rightAngle";
export declare type equilateralTriangleModeTypes = "top" | "right" | "bottom" | "left";
export declare type isoscelesTriangleModeTypes = "top" | "right" | "bottom" | "left";
export declare type scaleneTriangleModeTypes = "top" | "right" | "bottom" | "left";
export declare type rightAngleTriangleModeTypes = "top-left" | "top-right" | "bottom-left" | "bottom-right";
export declare type triangleModeTypes = equilateralTriangleModeTypes | isoscelesTriangleModeTypes | scaleneTriangleModeTypes | rightAngleTriangleModeTypes;
export interface ITriangle extends ViewProps {
    color: string;
    type?: triangleTypeTypes;
}
export interface IEquilateralTriangle extends ITriangle {
    type?: "equilateral";
    mode: equilateralTriangleModeTypes;
    base: number;
}
export interface IIsoscelesTriangle extends ITriangle {
    type: "isosceles";
    mode: isoscelesTriangleModeTypes;
    base: number;
    height: number;
}
export interface IRightAngleTriangle extends ITriangle {
    type: "rightAngle";
    mode: rightAngleTriangleModeTypes;
    base: number;
    height: number;
}
export interface IScaleneTriangle extends ITriangle {
    type: "scalene";
    mode: isoscelesTriangleModeTypes;
    height: number;
    left: number;
    right: number;
}
export declare type triangleProps = IEquilateralTriangle | IIsoscelesTriangle | IScaleneTriangle | IRightAngleTriangle;
declare const Triangle: ({ mode, base, color, type, height, left, right, style, ...otherProps }: triangleProps) => JSX.Element;
export default Triangle;
//# sourceMappingURL=index.d.ts.map